VERSION 5.00
Begin VB.Form Arcade 
   BackColor       =   &H80000000&
   Caption         =   "SloMo Arcade Emulator v0.2"
   ClientHeight    =   3915
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   3645
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3915
   ScaleWidth      =   3645
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox ArcadeScreen 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000007&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3910
      Left            =   0
      ScaleHeight     =   261
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   243
      TabIndex        =   0
      Top             =   0
      Width           =   3650
   End
   Begin VB.Menu mnuMain 
      Caption         =   "&Main"
      Begin VB.Menu mnuGames 
         Caption         =   "&Games"
         Begin VB.Menu mnuCentipede 
            Caption         =   "&Centipede"
         End
         Begin VB.Menu mnuMillipede 
            Caption         =   "&Millipede"
         End
      End
      Begin VB.Menu mnuResetCenti 
         Caption         =   "&Reset"
      End
      Begin VB.Menu mnuHyphen 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuEmulation 
      Caption         =   "&Emulation"
      Begin VB.Menu mnuViewCharSet 
         Caption         =   "&View Character Set"
      End
      Begin VB.Menu mnuEmuStop 
         Caption         =   "&Stop"
      End
   End
   Begin VB.Menu mnuAbout 
      Caption         =   "&About"
   End
End
Attribute VB_Name = "Arcade"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub ArcadeScreen_KeyDown(KeyCode As Integer, Shift As Integer)
Form_KeyDown KeyCode, 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
  SaveStatus
  End
End Sub

Private Sub mnuAbout_Click()
  'MsgBox "SloMo Arcade Emulator v0.1... Written by Tobias Strmstedt/Don Jarrett in 1998. Keyboard layout: Same as Mame. For credits please read Readme.txt"
  msg = "SloMo Arcade Emulator v0.2" & vbCrLf
  msg = msg & "By Don Jarrett and Tobias Strmstedt, 1998" & vbCrLf
  msg = msg & "Please read README.TXT for more details" & vbCrLf
  msg = msg & "Thank you for using SloMo v0.2"
  MsgBox msg, 64, "SloMo v0.2"
End Sub

Private Sub mnuCentipede_Click()
For ii& = 0 To 65536
    gameImage(ii&) = 0
Next ii&
CPURunning = 0
Main
mnuReset_Click
End Sub

Private Sub mnuEmuStop_Click()
CPURunning = 0
MsgBox "Exit Address=$" & Hex$(PC)
End Sub

Private Sub mnuExit_Click()
  End
End Sub

Private Sub mnuReset_Click()
  Dim FrameTime As Double
  Dim TotalTime As Double
  Dim NumberOfFrames As Integer
  ArcadeScreen.BackColor = &H0
  init6502
  reset6502
  LoadStatus
  NumberOfFrames = 0
  If game = "centipede" Then
  CPURunning = 1
  Do While KEY_ESC = 0
    FrameTime = Timer
    For test = 1 To 1024
      exec6502
      xx& = DoEvents
    Next test
    RedrawScreen
    TotalTime = TotalTime + (Timer - FrameTime)
    NumberOfFrames = NumberOfFrames + 1
    KEY_1 = 0
    KEY_2 = 0
    KEY_3 = 0
    KEY_CTRL = 0
    KEY_LEFT = 0
    KEY_RIGHT = 0
    KEY_UP = 0
    KEY_DOWN = 0
  Loop
  ElseIf game = "millipede" Then
    CPURunning = 1
    Do While KEY_ESC = 0
        For test = 1 To 5000
            exec6502
            DoEvents
        Next test
        RedrawScreen
        KEY_1 = 0
        KEY_2 = 0
        KEY_3 = 0
        KEY_CTRL = 0
        KEY_LEFT = 0
        KEY_RIGHT = 0
        KEY_UP = 0
        KEY_DOWN = 0
    Loop
  ElseIf game = "asteroids" Then
    For test = 1 To 4000
        exec6502
    Next test
    RedrawScreen
  End If
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  Select Case KeyCode
    Case 27: KEY_ESC = 1
    Case 51: KEY_3 = 1
    Case 50: KEY_2 = 1
    Case 49: KEY_1 = 1
    Case 17: KEY_CTRL = 1
    Case 38: KEY_UP = 1
    Case 37: KEY_LEFT = 1
    Case 40: KEY_DOWN = 1
    Case 39: KEY_RIGHT = 1
  End Select
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  Select Case KeyCode

  End Select
End Sub

Private Sub Form_Load()
  Arcade.Left = (Screen.Width - Arcade.ScaleWidth) / 2
  Arcade.Top = (Screen.Height - Arcade.ScaleHeight) / 2
  Arcade.Show
End Sub

Private Sub mnuMillipede_Click()
For ii& = 0 To 65536
    gameImage(ii&) = 0
Next ii&
CPURunning = 0
MilliMain
mnuReset_Click
End Sub

Private Sub mnuResetCenti_Click()
mnuReset_Click
End Sub

Private Sub mnuViewCharSet_Click()
CPURunning = 0
DisplayCharSet
End Sub
