Attribute VB_Name = "Millipede"
'  Millipede Implementation
Public DirRoms As String
Sub MilliMain()
  game = "millipede"
  SPRITE_OFFSET = &H13C0
  SPRITE_XPOS = &H13D0
  SPRITE_YPOS = &H13E0
  SCREEM_MEM = &H1000
  AddressMask = &H7FFF
  For test = 0 To 65536
    gameImage(test) = 0
  Next test
  For vx = 0 To 256
    For vy = 0 To 256
      VirtualScreen(1, vx, vy) = 0
      VirtualScreen(2, vx, vy) = 0
      'And the real screen
      Arcade.ArcadeScreen.PSet (vx, vy), RGB(0, 0, 0)
    Next vy
  Next vx
  
  loadchar "136013.106", 0
  loadchar "136013.107", 2048
  loadrom "136013.104", &H4000
  loadrom "136013.103", &H4000 + 4096
  loadrom "136013.102", &H4000 + 8192
  loadrom "136013.101", &H4000 + 12288
  
  KEY_ESC = 0
  KEY_3 = 0
  KEY_2 = 0
  KEY_1 = 0
  KEY_CTRL = 0
  KEY_UP = 0
  KEY_LEFT = 0
  KEY_DOWN = 0
  KEY_RIGHT = 0
  
  ' Millipede DipSwitches
  
  put6502memory &H408, 4
  put6502memory &H808, 4
  
  WarpChars
  
  init6502
  reset6502
  
End Sub
Public Function MilliRd(addr As Long) As Byte
    Dim Val As Byte
    If addr = &H2000 Then
        ' Wait for this, part joystick.
    ElseIf addr = &H40A Or addr = &H80A Then
        ' Implement Game randomizer here.
    ElseIf addr = &H2001 Then
        Val = &HFF
        If KEY_2 = 1 Then Val = Val Xor &H20
        If KEY_CTRL = 1 Then Val = Val Xor &H10
    ElseIf addr = &H2010 Or addr = &H2011 Then
        If KEY_UP = 1 Then Val = Val Xor &H8
        If KEY_DOWN = 1 Then Val = Val Xor &H4
        If KEY_LEFT = 1 Then Val = Val Xor &H2
        If KEY_RIGHT = 1 Then Val = Val Xor &H1
        gameImage(addr) = Val
    Else
        MilliRd = gameImage(addr)
    End If
End Function
Public Function MilliWr(addr As Long, value As Byte) As Byte
    If addr = &H2000 Then Exit Function
    gameImage(addr) = value
End Function

